#include <gtk/gtk.h>
#include <strings.h>
#include "menu.h"
#include "help.h"

/* Defined in life.c */
extern void run_life(GtkWidget *widget, gpointer data);
extern void stop_life(GtkWidget *widget, gpointer data);
extern void clear_table(GtkWidget *widget, gpointer data);

/* How the menu will look like */
static GtkItemFactoryEntry menu_items[] =
{
  {"/_File", NULL, NULL, 0, "<Branch>"},
  {"/File/Run", "<control>R", run_life, 0, NULL},
  {"/File/Stop", "<control>S", stop_life, 0, NULL},
  {"/File/Clear", "<control>C", clear_table, 0, NULL},
  {"/File/sep", NULL, NULL, 0, "<Separator>"},
  {"/File/Quit", "<control>Q", gtk_exit, 0, NULL},
  {"/_Specie", NULL, NULL, 0, "<Branch>"},
  {"/Specie/Dead", "<alt>D", set_specie_dead, 0, NULL},
  {"/Specie/Red", "<alt>R", set_specie_red, 0, NULL}, 
  {"/Specie/Blue", "<alt>B", set_specie_blue, 0, NULL}, 
  {"/Specie/Green", "<alt>G", set_specie_green, 0, NULL},
  {"/Specie/Yellow", "<alt>Y", set_specie_yellow, 0, NULL},
  {"/_Help", NULL, NULL, 0, "<LastBranch>"},
  {"/Help/sep", NULL, NULL, 0, "<Separator>"},
  {"/Help/About...", "<control>A", about_glife, 0, NULL}
};

/* Makes the menu-elements. */
void *make_menu(GtkWidget *window, GtkWidget **menubar)
{
  GtkItemFactory *factory;
  GtkAccelGroup *accelerator;
  gint number_of_menu_items = sizeof(menu_items) / sizeof(menu_items[0]);

  accelerator = gtk_accel_group_new();

  /* Initialize the factory. */
  factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accelerator);
  
  /* Creates the menues. */
  gtk_item_factory_create_items(factory, number_of_menu_items, menu_items,
				NULL);

  /* Attach the accelerator to the window. */
  gtk_accel_group_attach(accelerator, GTK_OBJECT(window));

  /* Return the menubar. */
  if(menubar)
    *menubar = gtk_item_factory_get_widget(factory, "<main>");
  else {
    g_print("Error:\n\tAn unexpected error occured during menu-creation.\n");
    exit(1);
  }
  return NULL; 
}



  
  



